// This class extends PreSecurity, which in turn extends Server.  It represents the checkin
// counters, and was needed because we needed a class that could send to either customs OR security.
// Since customs only sends to security, and nothing else sends to customs, this problem
// warranted its own class

public class CheckIn extends PreSecurity
{
  private int CUSTOMS_INDEX; // this keeps track of which array index represents the customs server
    
  /*
    pre: linkedTo isn't null, myName isn't null, master isn't null,indexOfCustoms represents the array index in linkedTo[] that the customs server is at
    post: constructs a CheckIn desk
  */
  public CheckIn(Server[] linkedTo,String myName, EventList master,long seederTime,double meanTime,int indexOfCustoms)
  { super(linkedTo,myName,master,seederTime,meanTime);
    this.CUSTOMS_INDEX = indexOfCustoms; // now we know which array index is customs
  }

  /*
    This function will either send a person to customs or security, depending on the person's requirements
    pre: who is not null
    post: the person object will end up in the queue of either customs or security, depending if they are fated for customs or not
  */
  private void goToCustoms(Person who,int currentTime)
  { if(who.fatedForCustoms()) // if the person is international...
    {
      //d.w(this.getName() + " sending to customs at time " + currentTime);
      this.linkedTo[CUSTOMS_INDEX].addPerson(who,currentTime); // send them to the linked server that we are told represents customs
      //d.w("Sending to customs");
    }
    else
    {
      //d.w(this.getName() + " Sending to security at time " + currentTime);
      goToSecurity(who,currentTime); // send them to one of the security servers.  This function is implemented in PreSecurity class
      //d.w("From checkin to Sec");
    }
  }

  public void sendToLink(Person who,int currentTime)
  { //d.w("sending from a check in counter");
    this.goToCustoms(who,currentTime);

  }
}