// This class is quite simple.  It contains a time of an event, and a link to the server where
// that event is happening.  These events get stockpiled in the EventList object, which will
// call the run method on whatever server an event links to.

public class Event extends Object
{
  private int when; // when the event happens
  private Server where; // where this event happens

  /*
    pre: where is not null
    post: constructs an event that will occur at server 'where' and time 'time'
  */
  public Event(int time,Server where)
  { this.when = time;
    this.where = where;
  }
  /*
    pre: none
    post: returns time
  */
  public int getTime()
  { return this.when;
  }

  /*
    pre: none
    post: returns the server that this events occurs at
  */
  public Server getServer()
  { return this.where;
  }
}