public abstract class Server extends Object
{
  protected Server[] linkedTo; // the servers that follow this one

  private Queue myQ; // the queue of people lined up for this server
  private String myName; // name of this server, such as security one, or something like that
  protected EventList eventMaster; // the master of all events
  private double meanTime;
  private Random myTimeRandom; // for random timing
  private Person user;

  protected StatsHolder stats; // for storing statistics

  public Server(Server[] linkedTo,String myName, EventList master, long seederTime,double meanTime)
  {
    this.myTimeRandom = new Random(seederTime);
    myQ = new Queue();
    this.myName = myName;
    this.meanTime = meanTime;
    this.linkedTo = linkedTo;
    this.eventMaster = master;
    user = null;

    stats = new StatsHolder(myName);
  }

  public String getName()
  { return this.myName;
  }

  public void addPerson(Person who,int currentTime)
  { this.myQ.push(who);
    if(this.free()) // if the new person is at the front of the line already, they need a new event made for them
    {  this.Run(currentTime); // this will add the person to the server, and add a new event
       stats.addUse(true, currentTime); //add usage time
    }

    stats.addLength(myQ.size(),currentTime); //Add current time, and size of the queue, measure until next time
  }

  protected void setNewEvent(int currentTime)
  { double timeSpent = this.myTimeRandom.nextExp(this.meanTime); // how long this customer spends here
    int eventTime = currentTime + (int)(timeSpent); // when they will be done
    this.eventMaster.addEvent(eventTime,this);
  }

  private void goToNext()
  {
  }

  public void Run(int currentTime)
  { // if run is called, that means an event occured at this server
    //the Time the person is done at the server

    if (user != null) this.sendToLink(user,currentTime); //send user to next server
    stats.addUse(false, currentTime);

    if ( myQ.size() > 0 )
    { user = (Person)this.myQ.pop(); //store user in server
      stats.addLength (this.myQ.size(), currentTime); //add length time
      stats.addUse(true, currentTime); //add usage time

      //add event for when server is free again
      this.setNewEvent(currentTime);

/**   if(this.myQ.size() > 0) // if there are people left in line
      { //d.w("Other people are waiting... creating new event");
      }
      else
      { stats.addUse(false, currentTime); //add usage time
      }
*/

    }
    else
    { this.user = null;
    }
  }

  abstract void sendToLink(Person who,int currentTime);

  public int RandomTime()
  { return -1;
  }

  public boolean free()
  { if (this.user == null) return true;
    return false;
  }

  public int goToWhich() // returns which exit the person should go to
  { /*double thisRandom = (double)(this.myRandom.nextUniformInt(1,100))/100;
    double lastTotal=0;
    double total =0;
    for(int x=0;x<this.probability.length;x++)
    { total += this.probability[x];
      if(thisRandom >= lastTotal && thisRandom < total)
      { return x;
      }
      lastTotal = total;
    }
    d.w("goToWhich - returning -1.  Likely an array out of bounds is about to happen");
    */
    return-1;
  }

  public StatsHolder getStats()
  { return stats;
  }

}