public class Simulation extends Object
{
    public Simulation()
    {
    }

    //pre:  ssPercent + fcPercent + ePercent = 1, s1Percent + s2Percent = 1
    //      ssPercent, fcPercent, ePercent, s1Percent, s2Percent, cPercent > 0
    //      ssPercent, fcPercent, ePercent, s1Percent, s2Percent, cPercent are accurate to 2 or fewer decimal places
    //      meanArrival, meanSS, meanFC, meanE, meanC, meanS > 0
    //post: returns a basket of statistics computed by one run of this
    //      simulation using seedA, seedSS, seedF, seedE, seedC, seedS1, seedS2, seedCheckIn, seedCustom, seedSec
    //      to initialize the pseudorandom number generators

    private EventList myMaster;

    public StatsBasket runSimulation(long seedA, long seedSS, long seedF, long seedE, long seedC, long seedS1, long seedS2,long seedCheckIn, long seedCustom, long seedSec,double meanArrival, double meanSS, double meanFC, double meanE, double meanC, double meanS,double ssPercent, double fcPercent, double ePercent, double cPercent, double s1Percent, double s2Percent)
    {
      this.myMaster = new EventList();
      //d.w("RUNNING SHIT1");
      Server sec1 = new Security(null,Constants.SEC_NAMES[0],myMaster,seedS1,meanS);
      Server sec2 = new Security(null,Constants.SEC_NAMES[1],myMaster,seedS2,meanS);

      //d.w("RUNNING SHIT2");
      double[] probs = new double[2];
      //d.w("RUNNING SHIT3");
      Server[] linkSec = new Server[2];
      linkSec[0] = sec1;
      linkSec[1] = sec2;
      Server customs = new PreSecurity(linkSec,"Customs",myMaster,seedC,meanC);

      Server [] checkins = new CheckIn[3];
      Server[] linkCheck = new Server[3];
      linkCheck[0] = linkSec[0];
      linkCheck[1] = linkSec[1];
      linkCheck[2] = customs;
      //d.w("RUNNING SHIT4");
      checkins[0] = new CheckIn(linkCheck,"Self-Service",myMaster,seedSS,meanSS,2);
      checkins[1] = new CheckIn(linkCheck,"First Class",myMaster,seedF,meanFC,2);
      checkins[2] = new CheckIn(linkCheck,"Economy",myMaster,seedE,meanE,2);

      probs = new double[3];
      probs[0] = ssPercent;
      probs[1] = fcPercent;
      probs[2] = ePercent;
      PeopleMaker people = new PeopleMaker(probs,checkins,"Arrival",myMaster,seedCheckIn,meanArrival,
                                      seedSec,seedCustom,cPercent,seedA,s1Percent,s2Percent);

      //d.w("RUNNING SHIT5");
      people.Run(0);
      //d.w("RUNNING SHIT6");

      d.w("LOOP::");
      while(!people.Done())
      { int curTime = this.myMaster.getNextEventTime();
        Event curEvent = this.myMaster.getNextEvent(curTime); // gets the next event occuring at curTime

        while(curEvent != null && !people.Done())
        { //d.w("------ new event -------");
          curEvent.getServer().Run(curTime);
          curTime = this.myMaster.getNextEventTime();
          curEvent= this.myMaster.getNextEvent(curTime);
        }
      }

      StatsHolder SSstats = checkins[0].getStats();
      StatsHolder Cstats = customs.getStats();
      StatsHolder S1stats = sec1.getStats();

      return new StatsBasket(SSstats.percentUse(), Cstats.percentUse(), S1stats.percentUse(),
                              SSstats.maxLength(), Cstats.maxLength(), S1stats.maxLength (),
                              SSstats.avgLength(), Cstats.avgLength(), S1stats.avgLength(),
                              StatsHolder.maxTime(), StatsHolder.avgTime());
      //      sec1.stats;
  //    customs.stats;
    //  checkins[0].stats;




      //Server arriveServer = new Server(tempProbs,tempLinks,"Arrivals",myMaster,seederExit,seederTime);
      //return null;// runs a simulation
    }
}
