public class StatsHolder extends Object
{ private static Queue timeSpent = new Queue();
  private static int numPeople; //Number of people in the system
  private static int numLeft; //Number of people that have left

  private Queue qLength;
  private Queue qInUse;
  private String serverName;

  public StatsHolder(String sName)
  { this.serverName = sName;
    qLength = new Queue();
    qInUse = new Queue();
  }

  public void addLength(int length, int time)
  { //add a Length element to the Length Queue
    if (numPeople >= 100 && numLeft <= 1900) qLength.push (new LengthOfQ(length,time));
  }

  public void addUse(boolean inUse, int time)
  { //add a Use element to the Use Queue
    //d.w(inUse + "::" +time);
    if (numPeople >= 100 && numLeft <= 1900) qInUse.push (new UseOfQ(inUse,time));
  }

  public static void fullTime(int startTime, int endTime)
  { if (numPeople >= 100 && numLeft <= 1900)
    { //add a person's full stay to the static Time queue
      Integer time = new Integer(endTime - startTime);
      timeSpent.push(time);
      //if (time.getInt() <= 0) d.w(startTime + "::" + endTime);
    }
  }

  public static void setPeople(int num)
  { numPeople = num; //num people in the system
  }

  public static int getPeople()
  { return numPeople;
  }

  public static void setLeft()
  { numLeft ++; //num people who have left the system
    //d.w(numLeft + " : out of : " + numPeople);
  }

  public int maxLength()
  { //post: Return the maximum length stored in Length Queue
    int max = 0;
    LengthOfQ temp;

    qLength.push(new LengthOfQ(-1,-1)); //Place holder at end of queue
    while(((LengthOfQ)qLength.peek()).getTime() != -1 )
    { temp = (LengthOfQ)qLength.peek();
      if (temp.getLength() > max) max = temp.getLength();
      qLength.push(qLength.pop()); //iterate through
    }
    qLength.pop();

    return max;
  }

  public double avgLength()
  { //post: Return weighted average length from stats in Length Queue
    double length = 0;
    LengthOfQ temp;
    int startTime = 0;
    int lastTime = 0;

    qLength.push(new LengthOfQ(-1,-1)); //Place holder at end of queue
    startTime = ((LengthOfQ)qLength.peek()).getTime();

    while(((LengthOfQ)qLength.peek()).getTime() != -1 )
    { temp = (LengthOfQ)qLength.pop();
      if (((LengthOfQ)qLength.peek()).getTime() != -1)
      /** if its not the last one (because that is used only for the upper time limit)
          take the length x (next time - its time)
      */
      { lastTime = ((LengthOfQ)qLength.peek()).getTime();
        length = length + temp.getLength() * (lastTime - temp.getTime());
      }
      qLength.push(temp); //iterate through
    }
    qLength.pop();

    return length / (lastTime - startTime);
  }

  public double percentUse()
  { //Post: Return the percent of time the queue was in use
    int startTime=0;
    int curTime = 0;
    int endTime = 1;
    int useTime = 0;
    UseOfQ use;
    startTime = ((UseOfQ)qInUse.peek()).getTime();

    // iterate through, adding the sum of time lengths when inUse is true, and divide the sum by the total time
    //d.w(""+ qInUse.size ());
    while(!qInUse.isEmpty())
    { use = (UseOfQ)qInUse.pop();
      curTime = use.getTime(); //get the time of this usage

      if (!qInUse.isEmpty())
      { endTime = ((UseOfQ)qInUse.peek()).getTime(); //time of next usage
        //d.w("" + endTime);
        if(use.getInUse())
        { useTime = useTime + (endTime - curTime);
          if (curTime > endTime) d.w("??");
          //d.w(useTime + "::" + use.getTime());
        }
      }
    }
    //d.w(endTime + "::" + startTime);
    d.w(useTime + "::" + endTime + "::" + startTime);
    return (double)(useTime / (double)(endTime - startTime));
  }

  public static int maxTime()
  { //Post: Return the longest time anoyone spent in the terminal
    int max = 0;
    int temp;

    timeSpent.push(new Integer(-1)); //Place holder at end of queue
    while(((Integer)timeSpent.peek()).getInt() != -1 )
    { temp = ((Integer)timeSpent.peek()).getInt();
      if (temp > max) max = temp;
      timeSpent.push(timeSpent.pop()); //iterate through
    }
    timeSpent.pop();
    return max;
  }

  public static double avgTime()
  { //Post: Return the average time spent in the terminal
    int temp = 0;
    //int count = 0;

    timeSpent.push(new Integer(-100)); //Place holder at end of queue

    while(((Integer)timeSpent.peek()).getInt() != -100 )
    { temp = temp + ((Integer)timeSpent.peek()).getInt(); //add the time
      //count ++;
      //int i = ((Integer)timeSpent.peek()).getInt();
      //if (i <= 0) d.w(i + "::" + temp + "::" + count);

      timeSpent.push(timeSpent.pop()); //iterate through
    }

    timeSpent.pop();

    //d.w(timeSpent.getSize() + "::" + temp);
    temp = temp / timeSpent.getSize(); //divide by total to get average
    //d.w("" + temp);
    return temp;
  }

}